package jMusic;

import jm.JMC;
import jm.music.data.*;
import jm.audio.*;
import jm.music.rt.*;

public class Melody1f extends RTLine implements JMC {
    int currentRow = 0;
    
    public static void main(String[] args) {
        Instrument inst = new SimpleFMInst(44100, 800, 34.4);
        new Melody1f(new Instrument[]{inst});
    }

    public Melody1f(Instrument[] insts) {
        super(insts);
        RTMixer mixer = new RTMixer(new RTLine[]{this});
        mixer.begin();
    }

    @Override
    public Note getNextNote() {
        boolean rollRed = ((currentRow ^ (currentRow - 1)) & 1) == 1;
        boolean rollGreen = ((currentRow ^ (currentRow - 1)) & 2) == 2;
        boolean rollBlue = ((currentRow ^ (currentRow - 1)) & 4) == 4;
        System.out.println((rollBlue ? "B" : "") + (rollGreen ? "G" : "") + (rollRed ? "R" : ""));
        currentRow = (currentRow + 1) % 8;
        Note n = new Note((int) (Math.random() * 12 + 60), QN, 100);
        return n;
    }
}
